var createError = require('http-errors');
var express = require('express');
var path = require('path');
var cookieParser = require('cookie-parser');
var logger = require('morgan');
var indexRouter = require('./routes/index');
var dependenciesRouter = require('./routes/dependencies');
var authRouter = require('./routes/auth');
var favicon = require('serve-favicon');
const session = require('express-session');
const config = require('./private/config');
var app = express();

app.use(session({
    secret: 'rdc-98765',
    resave: false,
    saveUninitialized: true
}))

require('console-error');
require('console-info');
require('console-warn');

// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(express.static(path.join(__dirname, 'public')));
app.use(favicon(path.join(__dirname,'public','images','favicon.ico')));

app.use('/', indexRouter);
app.use('/api', dependenciesRouter);
app.use('/', authRouter);

app.use('/static/js', express.static(__dirname + '/node_modules/handlebars/dist')); // redirect bootstrap JS
app.use('/static/js', express.static(__dirname + '/node_modules/bootstrap/dist/js')); // redirect bootstrap JS
app.use('/static/js', express.static(__dirname + '/node_modules/jquery/dist')); // redirect JS jQuery
app.use('/static/css', express.static(__dirname + '/node_modules/bootstrap/dist/css')); // redirect CSS bootstrap

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
